From: Cordell Bloor <cgmb@slerp.xyz>
Date: Wed, 8 Feb 2023 01:59:18 -0700
Subject: fix static initialization order

LinkAtLoadOrFirstTranslationUnitAccess must be constructed after
hsa_internal_api_table_, but that is not guaranteed when they
are in different translation units. By moving the objects into
the same translation unit, the order becomes defined.

Bug-Debian: https://bugs.debian.org/1031089
Forwarded: yes
Applied-Upstream: 5.6.0
---
 src/core/common/hsa_table_interface.cpp | 6 ------
 src/core/runtime/hsa_api_trace.cpp      | 6 ++++++
 2 files changed, 6 insertions(+), 6 deletions(-)

diff --git a/src/core/common/hsa_table_interface.cpp b/src/core/common/hsa_table_interface.cpp
index 7ea5966..b21fa66 100644
--- a/src/core/common/hsa_table_interface.cpp
+++ b/src/core/common/hsa_table_interface.cpp
@@ -57,12 +57,6 @@ const HsaApiTable* hsa_table_interface_get_table() {
   return hsaApiTable;
 }
 
-class Init {
- public:
-  Init() { rocr::core::LoadInitialHsaApiTable(); }
-};
-static Init LinkAtLoadOrFirstTranslationUnitAccess;
-
 // Pass through stub functions
 hsa_status_t HSA_API hsa_init() { return coreApiTable->hsa_init_fn(); }
 
diff --git a/src/core/runtime/hsa_api_trace.cpp b/src/core/runtime/hsa_api_trace.cpp
index ab6a1f3..39b57c7 100644
--- a/src/core/runtime/hsa_api_trace.cpp
+++ b/src/core/runtime/hsa_api_trace.cpp
@@ -403,3 +403,9 @@ void LoadInitialHsaApiTable() {
 
 }   //  namespace core
 }   //  namespace rocr
+
+class Init {
+ public:
+  Init() { rocr::core::LoadInitialHsaApiTable(); }
+};
+static Init LinkAtLoadOrFirstTranslationUnitAccess;
